#include <avr/interrupt.h>
#include "timer0.h"

// Timer0Overflow tritt alle 65,536 ms auf
// für ca. eine Stunde braucht's 54932 Timer-Overflows
#define CNT_START 54932

static volatile uint16_t ticker_cnt=0;
// ---------------------------------------------------------------------------------------------------------------------
// Private Funktionen
// ---------------------------------------------------------------------------------------------------------------------
// ticker_cnt pro IRQ eins runterzählen, Bei 0 nichts weiter tuen
ISR (TIMER0_OVF_vect)
{
  if (ticker_cnt != 0) ticker_cnt--;
}
// ---------------------------------------------------------------------------------------------------------------------
// Öffentliche Funktionen
// ---------------------------------------------------------------------------------------------------------------------
// Startet Count-Down-Timer neu
void ticker_start (void)
{
  cli();
  ticker_cnt=CNT_START;
  sei();
}
// ---------------------------------------------------------------------------------------------------------------------
// Gibt Status zurück ob eine Stunde seit letztem Tickerstart vergangen oder nicht
uint8_t ticker_get_status (void)
{
  cli();
  uint16_t tmp=ticker_cnt;
  sei();
    
  if (tmp == 0) return TICKER_TIMEOUT;
  else return TICKER_COUNT;
}
